% this si the main program to solve photodetector
%
warning off
%clear
%Parameters_NR
% initial condition of the hole and electron density
% initial condition of the hole and electron density
% ohmic contact p-NA_ion-n=0 and p*n=ni^2;NA_I=NA/(1+gA*p/p1), p1=NV*exp(-(EA-EV)/kT);
% then we calculate the equations to get the p at the boundary
% EA-EV=0.19eV, and EC_ED=0.07eV;
p1=NV*exp(-0.19);
n1=NC*exp(-0.07);
% boundary condition for the carrier density for ohmic contact
pb1=(-p1+sqrt(p1^2+16*p1*NA))/8;
nb1=ni(1)^2/pb1;
nbn=(-n1+sqrt(n1^2+16*n1*ND))/8;
pbn=ni(N)^2/nbn;
% NA_I% the ionization acceptor density NA_I=NA/(1+gA*p/p1), p1=NV*exp(-(EA-EV)/kT);
% ND_I% the ionization dopor density ND_I=ND/(1+gD*n/n1), n1=NC*exp(-(EC-ED)/kT);
% NB_I% the ionization dopor density NB_I=NB/(1+gD*n/n1), n1=NC*exp(-(EC-ED)/kT);

% pb1=NA;
% nb1=ni(1)^2/pb1;
% nbn=ND;
% pbn=ni(N)^2/nbn;

p(1:N1,1)=pb1;  % initial condition of the hole density for the first region. It depends on the acceptor doping density.
n(1:N1,1)=ni(1:N1,1).^2./p(1:N1,1); % in the equilibrium condition, p*n=ni^2.

n(N1:N2,1)=NB;% initial condition of the electron density for the second region. It depends on the donor doping density.
p(N1:N2,1)=ni(N1:N2,1).^2/NB;% in the equilibrium condition, p*n=ni^2

n(N2+1:N,1)=nbn;% initial condition of the electron density for the third region. It depends on the donor doping density.
p(N2+1:N,1)=ni(N2+1:N,1).^2./n(N2+1:N,1);% in the equilibrium condition, p*n=ni^2
%n(2:N2,1)=tan(1.565695+(1.570796-1.565695).*[0:N2-2]/(N2-2)); % this is tan function to create a smooth electron initial condition
% initial and boundary condition for the potential
w=zeros(N,1); % w is the potential unit V
for i=1:N1
    w(i)=log(-ni(i)/Tol(i))/si+0.001*(i-1); % this is the calculated potential in the acceptor(p) region.
end
for i=N1+1:N
    w(i)=log(Tol(i)/ni(i))/si+0.001*(i-N);% this is the calculated potential in the donor(n) region.
end
% boundary condition for p, n, and w
VT=NP.VT;
w=w/VT;

w(1)=w(1)-Bias/VT;
% boundary condition for p, n, and w
wb1=log(-ni(1)/Tol(1))/si;
wbn=log(Tol(N)/ni(N))/si;
wb1=wb1-Bias;
wb1=wb1/VT;% normolized potential
wbn=wbn/VT;% normolized potential

for i=2:N-1
    w(i)=((w(N)-w(1))/(N-1)^2)*((i-1)^2)+w(1);
end
% 
% fid=fopen('Results-IV\6\x.txt');  
% x=fscanf(fid,'%f');    
% fclose(fid);
% p=x(1:N)/Ni;
% n=x(N+1:2*N)/Ni;
% w=x(2*N+1:3*N)/VT;

%mesh1 = mesh_N(Lmin,Lmax,Length,NX);
%mesh1.Updatemesh(Lmin,Lmax,Length);
fd1=fd(mesh1);
x0=[p(2:end-1);n(2:end-1);w(2:end-1)];
ss = Semiconductor_Device(NP,Temperature,Length,mesh1,fd1,Tol,un,up,tn,tp,ni,w,Vps,Vns,Ep,Diameter,gamma); % Create the Device and initial condition.
DD0=Drift_Diff_N(pb1,pbn,nb1,nbn,wb1,wbn,fd1,mesh1,ss);
gama=ss.gama;% paprameter in the hole mobility
if capped
    remda(1:N-1,1)=1e-6/NP.NX;
    for i=2:N
        
        if mesh1.Lx(i)*NP.NX>=950e-7 & mesh1.Lx(i)*NP.NX<1000e-7
            remda(i-1)=0.7e-7/NP.NX;
        elseif mesh1.Lx(i)*NP.NX>=1000e-7 & mesh1.Lx(i)*NP.NX<1750e-7
            remda(i-1)=5e-7/NP.NX;
        elseif mesh1.Lx(i)*NP.NX>=1750e-7 & mesh1.Lx(i)*NP.NX<1950e-7
            remda(i-1)=2.5e-7/NP.NX;
        elseif mesh1.Lx(i)*NP.NX>=1950e-7
            remda(i-1)=8e-7/NP.NX;
        end
    end
    DD1 = Drift_Diff_N_C2(pb1,pbn,nb1,nbn,wb1,wbn,fd1,mesh1,ss,NP,GL,BF,remda);
    DD2 = Drift_Diff_N_C_GN2(pb1,pbn,nb1,nbn,wb1,wbn,fd1,mesh1,ss,NP,BF,remda);
else
    DD1 = Drift_Diff_N_C(pb1,pbn,nb1,nbn,wb1,wbn,fd1,mesh1,ss,NP,GL,BF,1,1);
    DD2 = Drift_Diff_N_C_GN(pb1,pbn,nb1,nbn,wb1,wbn,fd1,mesh1,ss,NP,BF,1,1);
    %DD2=Drift_Diff_NG(pb1,pbn,nb1,nbn,wb1,wbn,fd1,mesh1,ss,NP);
end
% for i=2:N-1
%     w(i)=((w(N)-w(1))/(N-1)^2)*((i-1)^2)+w(1);
% end


% read x from file
% fid=fopen('\x.txt');  
% x0=fscanf(fid,'%f');    
% fclose(fid); 
opts = optimset('Display','iter-detailed','TolFun',1e-8,'MaxIter',100,'Tolx',1e-6,'MaxIter',40000);
opts = optimset(opts, 'Diagnostics','off','Jacobian','on','DerivativeCheck','off');

[x,fval,exitflag,output,jacobian]=fsolve(@DD0.Newton_FD,x0,opts);
%x=[x;GL];
[x,fval,exitflag,output,jacobian]=fsolve(@DD1.Newton_FD,x,opts);
%[x,fval,exitflag,output,jacobian]=fsolve(@DD2.Newton_FD,x,opts);
% 
pm=x(1:N-2);
nm=x(N-1:2*N-4);
wm=x(2*N-3:3*N-6);
[Fp,Fn,Fw,Jp,Jn]=DD1.Cal_Current(pm,nm,wm,GL);
J0=NP.J0;
NX=NP.NX;
Ni=NP.Ni;
NT=NP.NT;
Js=trapz(mesh1.Lx_half,(((Jp+Jn)*J0).*Diameter(1:end-1).^2)/sum(mesh1.dx)*0.25*pi);
%J1=(sum(J1.*mesh1.dx)/sum(mesh1.dx))*J0*pi*(4.2e-4)^2;
% wb1=wb1+Js*50/NP.VT;
% if capped
%     remda(1:N-1,1)=1e-6/NP.NX;
%     for i=2:N
%         
%         if mesh1.Lx(i)*NP.NX>=950e-7 & mesh1.Lx(i)*NP.NX<1000e-7
%             remda(i-1)=0.7e-7/NP.NX;
%         elseif mesh1.Lx(i)*NP.NX>=1000e-7 & mesh1.Lx(i)*NP.NX<1750e-7
%             remda(i-1)=5e-7/NP.NX;
%         elseif mesh1.Lx(i)*NP.NX>=1750e-7 & mesh1.Lx(i)*NP.NX<1950e-7
%             remda(i-1)=2.5e-7/NP.NX;
%         elseif mesh1.Lx(i)*NP.NX>=1950e-7
%             remda(i-1)=8e-7/NP.NX;
%         end
%     end
%     %DD1 = Drift_Diff_N_C2(pb1,pbn,nb1,nbn,wb1,wbn,fd1,mesh1,ss,NP,GL,BF,remda);
%     DD2 = Drift_Diff_N_C_GN2(pb1,pbn,nb1,nbn,wb1,wbn,fd1,mesh1,ss,NP,BF,remda);
% else
%     %DD1 = Drift_Diff_N_C(pb1,pbn,nb1,nbn,wb1,wbn,fd1,mesh1,ss,NP,GL,BF);
%     DD2 = Drift_Diff_N_C_GN(pb1,pbn,nb1,nbn,wb1,wbn,fd1,mesh1,ss,NP,BF);
% end

p=Ni*[pb1;pm;pbn];
n=Ni*[nb1;nm;nbn];
w=VT*[wb1;wm;wbn];
%%%%%%%%%%%%%

L=NX*mesh1.Lx;
%%%%%%%%%%%
E=-(fd1.diffmp(w))/NX;
% subplot(211)
%  %plot([1:ti]*deltat,pevol,'gx')
%   plot(L(2:N),E,'g')
%   hold on;
% % 
% % subplot(212)
% plot(L,log10(p),'r')
% hold on
% plot(L,log10(n),'r')
%%%%%%%%%%%%%%%%%%%  
plot(L,log10(abs(Tol+p-n)),'r')
hold on
pm0=pm;
nm0=nm;
wm0=wm;
E0=E;
% % for the time evolution, 
Totaltime=50*2.0e-10/NT;
Steptime1=2e-12/NT;
Steps=Totaltime/Steptime1;
L1=(length(p)-2);
a=(-1/Steptime1).*[ones(2*L1,1);zeros(L1,1)];
Mt1=sparse(diag(a));
time(1)=0;
%%%%%%%%%%%%%%%%%%%%%%
% input
% time=2e-13:2e-13:2e-11
% G0=1e-3*(sin(1e12*time)+1)
  for ti=1:Steps
      if time(ti)<7.9e-9
          Steptime=100*Steptime1;
          Mt=Mt1/100;
      else
          Steptime=1*Steptime1;
          Mt=Mt1/1;
      end
      time(ti+1)=time(ti)+Steptime*NT;
      if time(ti+1)>Totaltime*NT
          break
      end
      err1=1;
      for i=1:10
          
          if err1<1e-13 && err2_p<1e-7
              %Jvt(ti)=JT(1)*J0;
              %Jvt1(ti)=JT(end)*J0;
              break
              
          end
          
          %Calculate F(x)
          [Fp,Fn,Fw,J1,J2]=DD2.Cal_Current(pm,nm,wm,time(ti+1),GL,FL);%pm is the hole density except the boundary, the same for nm and wm
          JT=J1+J2;
          %Jvt(ti)=JT(1)*J0;
          %Jvt1(ti)=JT(end)*J0;
          Fy = -[Fp;Fn;Fw];
          Ft=([pm-pm0;nm-nm0;wm-wm])/Steptime;
          Fy=Fy+Ft;
         % Calculate Jacobian
          %Jacob1 = Jacobm(mesh1,fd1,ss);
          M = DD2.ConsJacobian(pm,nm,wm);
          M=M+Mt;
          %Calculate Newton step
          Deltay = M\Fy;
          if any(isnan(Deltay))
              fprintf('Timestep: %d',ti);
              error('NaN found in timestep');
          end
          err0=norm(M*Deltay-Fy)/norm(Fy);
          
         % Update p,n and w
          pm = pm+Deltay(1:end/3);
          nm = nm+Deltay(end/3+1:2*end/3);
          wm = wm+Deltay(2*end/3+1:end);
          err1=norm(Deltay)/norm([p(2:end-1);n(2:end-1);w(2:end-1)]);
          
          err2_p=norm(Fp-(pm-pm0)/Steptime);
          err2_n=norm(Fn-(nm-nm0)/Steptime);
          err2_w=norm(Fw);
%            fprintf('timestep: %d',ti)
%           %fprintf('error1: %d,',err1)
%            fprintf('error2_p: %d ,error2_n: %d ,error2_w: %d\n',err2_p,err2_n,err2_w)
      end
      w=VT*[wb1;wm;wbn];
      p=Ni*[pb1;pm;pbn];
      n=Ni*[nb1;nm;nbn];
      E=-(fd1.diffmp(w))/NX;
      
      Jvt(ti)=trapz(mesh1.Lx_half,((JT*J0+Ebslon*(E-E0)/(NT*Steptime)).*Diameter(1:end-1).^2)/sum(mesh1.dx)*0.25*pi);%...
          %+trapz(mesh1.Lx_half,(Ebslon*(E-E0)/(Steptime).*(Diameter(1:end-1)).^2)/sum(mesh1.dx)*0.25*pi);% displacement current
      Jdis(ti)=trapz(mesh1.Lx_half,((Ebslon*(E-E0)/(NT*Steptime)).*Diameter(1:end-1).^2)/sum(mesh1.dx)*0.25*pi);;% displacement
      % consider the displacement current will influence the Load voltage.
      if ti>1
          Jdis1(ti)=0.25*pi*Diameter(1)^2*Ebslon*50*(Jvt(ti-1)-Jvt(ti))/(2.05e-4*NT*Steptime);
      else
          Jdis1=0;
      end
      %Jvt1(ti)=JT(1)*J0*pi*(4.2e-4)^2;%+Ebslon*(E(1)-E0(1))/(Steptime*NT);% un normolized value
      if 0
          dir001=['Results-G3/E',int2str(10+pai)];
          dir11=[dir001,'/L.txt'];
          fid = fopen(dir11,'w');
          fprintf(fid,'%8e\r\n',L);
          fclose(fid);
          dir13=[dir001,'/Pra2.txt'];
          fid = fopen(dir13,'w');
          fprintf(fid,'Steptime=%8e\r\n',Steptime*NT);
          fprintf(fid,'Frequence=%8e\r\n',FL);
          fprintf(fid,'Cap=%8e\r\n',capped);
          fprintf(fid,'Bias=%8e\r\n',Bias);
          fprintf(fid,'Gamma=%8e\r\n',gamma);
          fprintf(fid,'Intensity=%8e\r\n',G0);
          fprintf(fid,'BF=%8e\r\n',BF); %un=10000/NP.Nmu;% the electron mobility without Electrical Field, unit cm^2/(V*s)
          %up=200/NP.Nmu
          fprintf(fid,'Alphap=%8e\r\n',alphap);
          fprintf(fid,'Alphan=%8e\r\n',alphan);
          fprintf(fid,'un=%8e\r,up=%8e\r\n',un*NP.Nmu,up*NP.Nmu);
          fprintf(fid,'Diameter=%8e\r\n',Diameter);
          fclose(fid);
      end
      if  0%time(ti)>(50*2.0e-10)-(2e-10)
          dir11=[dir001,'/Jp',int2str(ii),int2str(ti),'.txt'];
          fid = fopen(dir11,'w');
          fprintf(fid,'%8e\r\n',J1*J0);
          fclose(fid);
          dir11=[dir001,'/Jn',int2str(ii),int2str(ti),'.txt'];
          fid = fopen(dir11,'w');
          fprintf(fid,'%8e\r\n',J2*J0);
          fclose(fid);
          dir11=[dir001,'/Jd',int2str(ii),int2str(ti),'.txt'];
          fid = fopen(dir11,'w');
          fprintf(fid,'%8e\r\n',Ebslon*(E-E0)/(NT*Steptime));
          fclose(fid);
%           dir11=[dir001,'/Jpdrift',int2str(ii),int2str(ti),'.txt'];
%           fid = fopen(dir11,'w');
%           fprintf(fid,'%8e\r\n',Jpdrift*J0);
%           fclose(fid);
%           dir11=[dir001,'/Jpdiff',int2str(ii),int2str(ti),'.txt'];
%           fid = fopen(dir11,'w');
%           fprintf(fid,'%8e\r\n',Jpdiff*J0);
%           fclose(fid);
          
          
          %           subplot(211)
          %           %plot([1:ti]*deltat,pevol,'gx')
          %           plot(L(2:N),E,'r')
          %           hold on;
          %
          %           subplot(212)
          %           plot(L,log10(p),'r')
          %           hold on
          %%           plot(L,log10(n),'r')
          %           pause(1)
      end
      E0=E;
      pm0=pm; % for the time evolution to record the last timestep carrier density and potential
      nm0=nm;
      wm0=wm;
  end
%[x,fval,exitflag,output,jacobian]=fsolve(@DD2.Newton_FD,x,opts);
%%%%%%%%%%%%%
%plot(time(2:end),Jvt)
p=Ni*[pb1;pm;pbn];
n=Ni*[nb1;nm;nbn];
w=VT*[wb1;wm;wbn];
%%%%%%%%%%%%%

L=NX*mesh1.Lx;
%%%%%%%%%%%
E=-(fd1.diffmp(w))/NX;

%  subplot(211)
%  %plot([1:ti]*deltat,pevol,'gx')
%  plot(L(2:N),E,'g')
%  hold on;
% 
% subplot(212)
% plot(L,log10(p),'g')
% hold on
% plot(L,log10(n),'g')
%%%%%%%%%%%%%%%%%%%

