function Main_harmonic_bias()
close all
Harmonic_exp1; % this is the experiment results.
filenum=1;
gamma=4;
up=300;
dir=['Results/G7/',int2str(filenum)];
mkdir(dir);
tic
%inpx=str2num(getenv('SLURM_ARRAY_TASK_ID'));
inpx=8:20; % this is the bias range need to calculate(inpx/4)
for main_i=inpx
    
    deltaV=1;
    BIAS1=main_i/4; % the bias
    G00=16.5;%10.5526 21.0526/17 for Campbell Franz unit power light mW.conresponse to the light generation of 0.0012 % 1.2 % 0.12
    % this is the power of the light of input
    
    Ae=1.5e7; % the following four parameter is for the impact ionization
    Be=1.9e6;
    Ah=0;
    Bh=2.26e6;
    Impact_Ion=1; % 1 is impact ionization is on , 0 is off
    BF=0;
    Fre=2e9; % frequenece
    DeltaEA=0.025; % doping level , for acceptor
    DeltaED=0.005; % doping level for donor
    
    if BIAS1==2
        [p,n,w,Js]=SteadyPDsolver(2,BF,G00,gamma,up,0,Ae,Be,Ah,Bh,0,0,0,0,0,deltaV,DeltaEA,DeltaED);
        [p,n,w,Js]=SteadyPDsolver(2,BF,G00,gamma,up,Impact_Ion,Ae,Be,Ah,Bh,1,p,n,w,Js,deltaV,DeltaEA,DeltaED);
        [p,n,w,Js,Jvt,Jdis,Jtp,Jtn]=DynamicPDsolver(BIAS1,BF,G00,Fre,'Results/G7/',filenum,Ae,Be,0,2.26e8,gamma,up,1,p,n,w,Js,DeltaEA,DeltaED,Impact_Ion);
    else%if BIAS1==2.5|BIAS1==2|BIAS1==6
        [p,n,w,Js]=SteadyPDsolver(BIAS1,BF,G00,gamma,up,0,Ae,Be,Ah,Bh,0,0,0,0,0,deltaV,DeltaEA,DeltaED);
        [p,n,w,Js]=SteadyPDsolver(BIAS1,BF,G00,gamma,up,Impact_Ion,Ae,Be,Ah,Bh,1,p,n,w,Js,deltaV,DeltaEA,DeltaED);
        [p,n,w,Js,Jvt,Jdis,Jtp,Jtn]=DynamicPDsolver(BIAS1,BF,G00,Fre,'Results/G7/',filenum,Ae,Be,0,2.26e8,gamma,up,1,p,n,w,Js,DeltaEA,DeltaED,Impact_Ion);
     
    end
    toc
    % p ,n,w are the steady state solution carrier density and potential
    % ,initial state is to decide weather to calculate the results using the
    % given initial guess. For the first calculation, initial should be zero,
    % for the increasing applied voltage, initial state should set to 1, and
    % using the previous results as the initial guess.
    %[p,n,w,Js,Jvt,Jdis]=DynamicPDsolver(Bias,BF,G0,FL,dir,filenum1,gamma,up,Ae,Be,Ah,Bh)
    if 1%BIAS1==2|BIAS1==2.5|BIAS1==6
        %     dir=['Results/G7/',int2str(filenum)];
        dir11=[dir,'/J',num2str(main_i),'.txt'];
        fid = fopen(dir11,'w');
        fprintf(fid,'%8e\r\n',Jvt);
        fclose(fid);
        dir12=[dir,'/Jpt',num2str(main_i),'.txt'];
        fid = fopen(dir12,'w');
        fprintf(fid,'%8e\r\n',Jtp);
        fclose(fid);
        dir12=[dir,'/Jnt',num2str(main_i),'.txt'];
        fid = fopen(dir12,'w');
        fprintf(fid,'%8e\r\n',Jtn);
        fclose(fid);
        dir12=[dir,'/Jdis',num2str(main_i),'.txt'];
        fid = fopen(dir12,'w');
        fprintf(fid,'%8e\r\n',Jdis);
        fclose(fid);
    end
    % here is to plot the harmonic power
    dT=1e-12; % sampleing time
    L=round(1*1/Fre/dT); % choose one period
    % smapling time
    Fs=1/dT;
    y=Jvt(end-L+1:end);
    % analysis of harmonic
    
    F1(main_i)=2*abs(1/L*sum(y.*exp(1i*2*pi*1*Fre*[0:dT:dT*(L-1)])));%/sum(wb)*L;
    F2(main_i)=2*abs(1/L*sum(y.*exp(1i*2*pi*2*Fre*[0:dT:dT*(L-1)])));%/sum(wb)*L;
    F3(main_i)=2*abs(1/L*sum(y.*exp(1i*2*pi*3*Fre*[0:dT:dT*(L-1)])));%/sum(wb)*L;
    % here is going to plot the harmonic power as a function of bias at one
    % point
    close all
    Harmonic_exp1;
    plot([8:main_i]/4,10*log10(50*(1/2*F1(8:main_i).^2)*1000),'go-','linewidth',2)
    hold on
    plot([8:main_i]/4,10*log10(50*(1/2*F2(8:main_i).^2)*1000),'go-','linewidth',2)
    plot([8:main_i]/4,10*log10(50*(1/2*F3(8:main_i).^2)*1000),'go-','linewidth',2)
    drawnow
    
end
% when we finish all the bias harmonic power calculation, we are going to
% plot the figure of harmonic power as a function of bias.
close all
Harmonic_exp1;
Y=1:20;
plot(Y/4,10*log10(50*(1/2*F1.^2)*1000),'go-','linewidth',2)
hold on
plot(Y/4,10*log10(50*(1/2*F2.^2)*1000),'go-','linewidth',2)
plot(Y/4,10*log10(50*(1/2*F3.^2)*1000),'go-','linewidth',2)
% this is to set up the figure
xl = xlabel('Bias (V)');
yl = ylabel('Harmonic Power (dBm)');
axis([2,5,-130,0])
set(gca, 'FontSize',14,'FontName','Times New Roman')
set(xl, 'FontSize',14,'FontName','Times New Roman')
set(yl, 'FontSize',14,'FontName','Times New Roman')
set(gcf, 'PaperPosition',[0 0 4 3],'PaperSize',[4 3])
set(gca, 'XMinorGrid', 'off')
grid on;
set(gca,'XMinorTick','on')

