classdef PD_Structure < handle
    properties
        Num_Layer % number of layers
        Layer_Material % the material of each layer
        Layer_Lx % the position of each layer
        Type_Layer % the type of each layer 1for p,-1for n, 0 for i;
        Layer_Doping % Doping information
        Node % node of each layer
        
        NC % conduction band density  in numerical 
        NV % valance band density  in numerical 
        ni % numerical intrisic density
        tn % electron life time numerical 
        tp % hole life time numerical
        Tol %doping density of layer in numerical 
        un
        up
        R_Ebslon% relatively Ebslon INGaAs is one;
        Phi % parameter in Franz_keldysh effect
        Eg % energy gap in InGaAs
        %Doping % numerical doping information
        % recombination coefficient
        Cp
        Cn
        Br
        Vns
        Vps
        beta
    end
    
    methods
        function self=PD_Structure(Num_Layer, Layer_Material, Layer_Lx,Type_Layer,Layer_Doping,Node,NC1,NC2,NV1,NV2,ni1,ni2,...
                tor1,tor2,un1,un2,up1,up2,R_Ebslon2,Phi,Eg,Cp1,Cp2,Cn1,Cn2,Br1,Br2,Vns1,Vns2,Vps1,Vps2,beta1,beta2)
            self.Num_Layer = Num_Layer;
            self.Layer_Material = Layer_Material;
            self.Layer_Lx = Layer_Lx;
            self.Type_Layer = Type_Layer;
            self.Layer_Doping = Layer_Doping;
            self.Node = Node;
            self.NC = zeros(Node(end),1);
            self.NV = zeros(Node(end),1);
            self.ni = zeros(Node(end),1);
            self.Tol = zeros(Node(end),1);
            self.tn = zeros(Node(end),1);
            self.tp = zeros(Node(end),1);
            self.un = zeros(Node(end),1);
            self.up = zeros(Node(end),1);
            self.Cp = zeros(Node(end),1);
            self.Cn = zeros(Node(end),1);
            self.Br = zeros(Node(end),1);
            self.R_Ebslon=ones(Node(end),1);
            self.Vns = zeros(Node(end),1);
            self.Vps = zeros(Node(end),1);
            self.beta = zeros(Node(end),1);
            self.Phi=Phi;
            self.Eg=Eg;
            if Layer_Material(1)==1
                self.NC(1:Node(1))=NC1;
                self.NV(1:Node(1))=NV1;
                self.ni(1:Node(1))=ni1;
                self.un(1:Node(1))=un1;
                self.up(1:Node(1))=up1;
                self.Cp(1:Node(1))=Cp1;
                self.Cn(1:Node(1))=Cn1;
                self.Br(1:Node(1))=Br1;
                self.Vns(1:Node(1))=Vns1;
                self.Vps(1:Node(1))=Vps1;
                self.beta(1:Node(1))=beta1;
            elseif Layer_Material(1)==2
                self.NC(1:Node(1))=NC2;
                self.NV(1:Node(1))=NV2;
                self.ni(1:Node(1))=ni2;
                self.un(1:Node(1))=un2;
                self.up(1:Node(1))=up2;
                self.Cp(1:Node(1))=Cp2;
                self.Cn(1:Node(1))=Cn2;
                self.Br(1:Node(1))=Br2;
                self.Vns(1:Node(1))=Vns2;
                self.Vps(1:Node(1))=Vps2;
                self.beta(1:Node(1))=beta2;
                self.R_Ebslon(1:Node(1))=R_Ebslon2;
            end
            if Type_Layer(1)==0
                self.tn(1:Node(1)) = tor1;
                self.tp(1:Node(1)) = tor1;
            else
                self.tn(1:Node(1)) = tor2;
                self.tp(1:Node(1)) = tor2;
            end
            self.Tol(1:Node(1))=Layer_Doping(1);
            for i=2:Num_Layer
                
                if Layer_Material(i)==1
                    self.NC(Node(i-1)+1:Node(i))=NC1;
                    self.NV(Node(i-1)+1:Node(i))=NV1;
                    self.ni(Node(i-1)+1:Node(i))=ni1;
                    self.un(Node(i-1)+1:Node(i))=un1;
                    self.up(Node(i-1)+1:Node(i))=up1;
                    self.Cp(Node(i-1)+1:Node(i))=Cp1;
                    self.Cn(Node(i-1)+1:Node(i))=Cn1;
                    self.Br(Node(i-1)+1:Node(i))=Br1;
                    self.Vns(Node(i-1)+1:Node(i))=Vns1;
                    self.Vps(Node(i-1)+1:Node(i))=Vps1;
                    self.beta(Node(i-1)+1:Node(i))=beta1;
                elseif Layer_Material(i)==2
                    self.NC(Node(i-1)+1:Node(i))=NC2;
                    self.NV(Node(i-1)+1:Node(i))=NV2;
                    self.ni(Node(i-1)+1:Node(i))=ni2;
                    self.un(Node(i-1)+1:Node(i))=un2;
                    self.up(Node(i-1)+1:Node(i))=up2;
                    self.Cp(Node(i-1)+1:Node(i))=Cp2;
                    self.Cn(Node(i-1)+1:Node(i))=Cn2;
                    self.Br(Node(i-1)+1:Node(i))=Br2;
                    self.Vns(Node(i-1)+1:Node(i))=Vns2;
                    self.Vps(Node(i-1)+1:Node(i))=Vps2;
                    self.beta(Node(i-1)+1:Node(i))=beta2;
                    self.R_Ebslon(Node(i-1)+1:Node(i))=R_Ebslon2;
                end
                if Type_Layer(i)==0 % life time in i region or doped region
                    self.tn(Node(i-1)+1:Node(i)) = tor1;
                    self.tp(Node(i-1)+1:Node(i)) = tor1;
                else
                    self.tn(Node(i-1)+1:Node(i)) = tor2;
                    self.tp(Node(i-1)+1:Node(i)) = tor2;
                end
                self.Tol(Node(i-1)+1:Node(i))=Layer_Doping(i);
                
            end
            
        end
    end
    
    
    
end