% parameter and initial condition
% KB=1.38e-23;% Boltzmann constant,unit,J/K
% q=1.6e-19;
% Ebslon=1.21e-12;% 8.85*e-12F/m=8.85*e-14F/cm
% %Ebslon=4*8.85e-14; % unit F/cm
% Ni=1.4e16;%Intrisic density normilized density
% Temperature=300;
% VT=KB*Temperature/q;% normalized voltage or potential
% NX=sqrt(Ebslon/q*VT/Ni);% normolized position x
% D0=8000*VT;%normolized diffusion coeificient
% NT=NX^2/D0;% normolized time t
% Nmu=D0/VT;% normolized mobility;
% J0=q*D0*Ni/NX;
%         KB=1.38e-23;% Boltzmann constant,unit,J/K
%         q=1.6e-19;
%         T=300;
%clear
KB=1.38e-23;% Boltzmann constant,unit,J/K
q=1.6e-19;
Ebslon=1.21e-12;% 8.85*e-12F/m=8.85*e-14F/cm
R_Ebslon2= 1; % relatively Ebslon in INP compared in InGaAs.

%Ebslon=4*8.85e-14; % unit F/cm
Ni=1.4e16;%Intrisic density normilized density
Temperature=300;
% beta=8e-8/(2.2^(abs(Bias)-2)); % larger ,saturates quickly in InGaAs
beta=8e-8;
beta2=8e-8; % in InP
NP=Norm_parameter(KB,q,Ebslon,Ni,Temperature,beta,beta2);
si=38.5;% this is q/K*T, K is boerzman, T is temperature.
Phi=1.8e4; % parameters in the Franz_keldysh (Campbell's Franz)
alpha0=2e4;% absorption coe
Franz=1; % Franz==1 use my Franz. 2 use campbell's Franz

In=1.05;% parameters for the impact ionization
Ip=1.05; % parameters for the impact ionization

%%%mesh
Dmin=1;% unit nm
Dmax=1;% unit nm
Deven=2;
Length=1490; % The Total length of the photodetector, unit cm
%mesh1=evenmesh(Deven,Length,NP.NX);
%mesh1=Variablemesh_keith(Dmin,Dmax,Length,NP.NX);
mesh1=Variablemesh1(Dmin,Dmax,Length,NP.NX);
% N1=mesh1.N1;% The first region(p region) from Node 1 to 100
% N2=mesh1.N2;% The second region(i region, actually light n region) from Node 101 to 195
N=mesh1.N;% The total nodes 
%%%%%%%%%
NV1=1.1511e19/NP.Ni; % the DOS of vanlacne band of InGaAs
NC1=2.083e17/NP.Ni; % the DOS of conduction band of InGaAs
NV2=1.3e19/NP.Ni;% the DOS of vanlacne band of InP
NC2=5.7e17/NP.Ni;% the DOS of conduction band of InP

Eg1=0.71-abs(Bias)/5*0.015; % energy gap in InGaAs
%Eg1=0.70;
ni1=6e12/NP.Ni;
ni2=1.29e7/NP.Ni;
tor1=2e-8/NP.NT; % 2e-8 for the current 
tor2=2e-11/NP.NT; % 3e-12
% radar recombination and auger recombination
Cp1=2e-28*NP.NT/(NP.NX)^6;
Cp2=2e-28*NP.NT/(NP.NX)^6;
Cn1=Cp1;
Cn2=Cp2;
Br1=1e-10*NP.NT/(NP.NX)^3;
Br2=1e-10*NP.NT/(NP.NX)^3;;
%%
un=22000/NP.Nmu;% the electron mobility without Electrical Field, unit cm^2/(V*s)
un1=14000/NP.Nmu;
un2=5000/NP.Nmu; % INp
up1=500/NP.Nmu;
up2=500/NP.Nmu;%INP

Vps=1e7*NP.NX/NP.VT/NP.Nmu;
Vps2=1e7*NP.NX/NP.VT/NP.Nmu;
Vns=3e7*NP.NX/NP.VT/NP.Nmu;
Vns2=1e7*NP.NX/NP.VT/NP.Nmu; % velocity in InP

% create a class Structure
Num_Layer = 10;
% 1 for InGaAs, 2 for InP
Layer_Material = [1,2,1,1,1,1,1,1,1,2];
Layer_Lx = [0,30,230,380,530,680,930,950,970,990,1490];
Type_Layer = [1,1,1,1,1,0,-1,-1,-1,-1]; % 1 for p, -1 for n, 0 for i;
Layer_Doping = [-2e19, -2e19,-2e18,-1e18,-5e17,1e15,0.5e18,1e18,2e18,2e19];
%Layer_Doping = [-2e18, -2e18,-2e18,-1e18,-5e17,0,0.5e17,1e17,2e17,2e17];
PD_Str1 = PD_Structure(Num_Layer, Layer_Material, Layer_Lx, Type_Layer,Layer_Doping,mesh1.Node,NC1,NC2,NV1,NV2,ni1,ni2,tor1,tor2,...
    un1,un2,up1,up2,R_Ebslon2,Phi,Eg1,Cp1,Cp2,Cn1,Cn2,Br1,Br2,Vns,Vns2,Vps,Vps2,NP.beta,NP.beta2);
%PD_Structure(Num_Layer, Layer_Material, Layer_Lx,Type_Layer,Layer_Doping,Node,NC1,NC2,NV1,NV2,ni1,ni2,tor1,tor2)
NC=PD_Str1.NC;
NV=PD_Str1.NV;
ni=PD_Str1.ni;
tn=PD_Str1.tn;
tp=PD_Str1.tp;
% un=PD_Str1.un;
% up=PD_Str1.up;
Tol=PD_Str1.Tol/NP.Ni;
R_Ebslon=PD_Str1.R_Ebslon;
% N1 is the p-i interface
% N2 is the i-n interface;
N1=mesh1.Node(5);
N2=mesh1.Node(6);


 Diameter(1:N,1)=35e-4; % Beam Diameter unit cm
 DiameterJ(1:N,1)=35e-4; 

%  Diameter(1:N1)=6e-4; %
 %DiameterJ=Diameter;
%dx(1:N-1,1)=0.25e-6; % the distance between the nodes, unit cm
% no normolized here, inside the current normolized there

%up=300/NP.Nmu;% the hole mobility without Electrical Field, unit cm^2/(V*s)

Ep=2e3*NP.NX/NP.VT; % 4e3
R_load=50;

% 
%     fclose(fid);
