classdef Variablemesh1 < handle
    %UNTITLED Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        Dmin
        Dmax
        Length
        NX% normliazed x
        dx % the spacing between main point
        dx1 % the spacing between the middle point
        Lx% the position of the nodes
        Node % the layer node information
        N
        N1 % p-i interface
        N2 % i-n interface
        N_absorp % absorption end node
    end
    properties
        Lx_half
    end
    methods
        function self = Variablemesh1(Dmin,Dmax,Length,NX)
            self.Dmin = Dmin;
            self.Dmax = Dmax;
            self.Length = Length;
            self.NX = NX;
            % w is the width of the region of change
            % the smaller the faster the grid points will change
            %w = 0.2;
            
            % xt is the relative position of the grid size change
            %xt = 0.5;
            [self.dx,self.dx1,self.Lx,self.N,self.Node]=self.createmesh(0.8,0.5);
            self.dx=self.dx'/NX;
            self.dx1=self.dx1'/NX;
            self.Lx=self.Lx'/NX;
            self.Lx_half = (self.Lx(1:end-1)+self.Lx(2:end))/2;
            self.N1=self.Node(5);
            self.N2=self.Node(6);
            self.N_absorp = self.Node(9);
        end
                function [y,N]= create_uneven_mesh(self,Y0,Y1,h1,h2,xt,w)
            % The linear transition has average spacing
            hav = (h1+h2)/2;
            
            % The region lengths
            L = (Y1-Y0);
            L1 = L*(xt-w/2);
            L2 = L*(1-xt-w/2);
            
            % Calculate the number of gridpoints in each section
            N1 = round(L1/h1);
            N2 = round(L2/h2);
            
            % Calculate the leftover transition region
            Lw = L-N1*h1-N2*h2;
            Nw = round(Lw/hav);
            
            % The quadratic coefficient
            a = 0.5*(h2-h1)/Nw;
            
            % Calculate the step-size shift to ensure an integer
            % number of nodes in the transition region
            hshift = Lw/Nw-hav;
            
            % The grid
            N = round(N1+N2+Nw);
            n = [0:1:N];
            
            % Regions
            sn1 = n<N1;
            sn2 = N1<=n & n<=(N-N2);
            sn3 = (N-N2)<n;
            
            y(sn1) = h1*n(sn1);
            y(sn2) = a*(n(sn2)-N1).^2 + (h1+hshift)*(n(sn2)-N1) + h1*N1;
            y(sn3) = h2*n(sn3) + L - h2*N;
            
            y = y + Y0;
        end
        
        function [y,N] = create_even_mesh(self,X0,X1,h)
            y = [X0:h:X1];
            N=length(y);
        end
             function [dx,dx1,Lx,N,Node]=createmesh(self,w,xt)
            d1=self.Dmin;
            d2=self.Dmax;
            % function [y,N1,N2,N,w,xt,h1,h2,h3]=variable_nodes_linear
            

            
            % The grid sizes
            h1=d2;%max
            h2=d1;%min
            h3=d2;
            
            [y1,n1] = self.create_even_mesh(0,30,h1); %unit nm L1
            [y2,n2] = self.create_even_mesh(30,230,h1); %unit nm L2
            [y3,n3] = self.create_even_mesh(230,380,h1); %unit nmL3
            [y4,n4] = self.create_even_mesh(380,530,h1); %unit nmL4
            [y5,n5] = self.create_even_mesh(530,650,h1); %unit nm L5
            
            [y6,n6] = self.create_uneven_mesh(650,680,h1,h2,xt,w); %L5
            [y7,n7] = self.create_uneven_mesh(680,800,h2,h3,xt,w); %L6
            %[y3,n3] = self.create_even_mesh(1200,1000,h2);
            [y8,n8] = self.create_even_mesh(800,900,h1); %L6
            [y9,n9] = self.create_uneven_mesh(900,930,h1,h2,xt,w); % L6
            %[y6,n6] = self.create_even_mesh(1050,1950,h2);
            %[y7,n7] = self.create_even_mesh(1950,2050,h2);
            %
            [y10,n10] = self.create_even_mesh(930,950,h2); % L7
            [y11,n11] = self.create_even_mesh(950,970,h2); % L8
            [y12,n12] = self.create_even_mesh(970,990,h2); % L9
            [y13,n13] = self.create_uneven_mesh(990,1100,h2,h1,xt,w); % L10
            [y14,n14] = self.create_even_mesh(1100,1490,h1); % L10
            
            %[y8,n8] = self.create_uneven_mesh(1950,2050,h2,h3,xt,w);
            %[y8,n8] = self.create_uneven_mesh(1900,2000,h2,h3,xt,w);%unit nm
            
%             save('mesh','w','xt','h1','h2','h3');
%             fid = fopen('mesh.txt','w');
%             fprintf(fid,'w=%8e\r\n',w);
%             fprintf(fid,'xt=%8e\r\n',xt);
%             fprintf(fid,'h1=%8e\r\n',h1);
%             fprintf(fid,'h2=%8e\r\n',h2);
%             fprintf(fid,'h3=%8e\r\n',h3);
%             fclose(fid)
            
            % Append meshes removing repeated boundary points
            y = (1e-7)*[y1  y2(2:end) y3(2:end)  y4(2:end) y5(2:end) y6(2:end) y7(2:end) y8(2:end) y9(2:end) y10(2:end) y11(2:end) y12(2:end) y13(2:end) y14(2:end)];
           % constructure a structure to store the node information of the
           % layers there are 10layers in the device.
            Lx=y;
            dx=diff(y);
            dx1=0.5*(dx(1:end-1)+dx(2:end));
             N=length(y);
             Node(1)=n1;
             Node(2)=n1+n2-1;
             Node(3)=n1+n2+n3-2;
             Node(4)=Node(3)+n4-1;
             Node(5)=Node(4)+n5+n6-1;
             Node(6)=Node(5)+n7+n8+n9-1;
             Node(7)=Node(6)+n10-1;
             Node(8)=Node(7)+n11-1;
             Node(9)=Node(8)+n12-1;
             Node(10)=Node(9)+n13+n14-1;
             %Node(11)=N;
            if 0
                subplot(311)
                plot(y,'k*-')
                xlabel('Node number, n')
                ylabel('Node position')
                
                subplot(312)
                plot(diff(y),'ro-');
                xlabel('Node number, n')
                ylabel('Node spacing')
                
                subplot(313)
                plot(diff(y,2),'ro-');
                xlabel('Node number, n')
                ylabel('Spacing change')
            end
            
            
        end
        

    end
    
end

