function T=solveheattrans(J,E,Eg,R,G,ss1,T0)
% the function is to solve heat transfer in the device in 1D model in
% steady state
% the input parameters are J: current, E: electric field, Eg: the device
% energy gap at T=300. NP: normal parameters provide Kb, R and G are the
% recombination and generation rates. T are the temperature in the device
% DP is the class has the device material parameters 

rho=4.5e-3; % rho is the mass density unit kg/cm-3
c=381*1e-4; % specific heat of the material unit m^2s^-2K-1

fd=ss1.fd;
NP=ss1.NP;
Text=300;
h1=0.5;% conductivity with external 
h2=0.5; % conductivity with external 

deltat=1e-10;
N=length(T0)-2;
T0(2:end-1)=T0(2:end-1)+rand(N,1);
T=T0;
T(1)=Text;

for i=1:1
%     Kia=0.35*(T./300).^(-1.15); % it is as a function of Temperature
%     FTe=(1/(c.*rho))*((fd.diff3p(Kia)).*(fd.diff3p(T))/(NP.NX^2)+0.25*(J(1:end-1)+J(2:end)).*(E(1:end-1)+E(2:end))+1.e-19*Eg(2:end-1).*(R(2:end-1)-G(2:end-1)));
%     T(2:end-1)=T(2:end-1)+deltat*FTe;
%     T(1)=(T(2)+Text)/2;
%     T(end)=(T(end-1)+Text)/2;
    %the Jacobia matrix
    DD=Heatsolver(J,E,Eg,R,G,ss1,T)
    opts = optimset('Display','iter-detailed','TolFun',1e-8,'MaxIter',100,'Tolx',1e-6,'MaxIter',100);
        opts = optimset(opts, 'Diagnostics','on','Jacobian','off','DerivativeCheck','off','Algorithm','trust-region-dogleg');
        [T1,fval,exitflag,output,jacobian]=fsolve(@DD.Newton_FD,T(2:end-1),opts);
        y=DD.caly(T1);
%        plot(T1)
       T=[T(1);T1;T(end)];
%     DKiaDT=0.35*(-1.15)*(T./300).^(-2.15)/300;
%     B=(1/(c.*rho))*([0;DKiaDT(3:end-1)./(fd.mesh.dx(1:end-2)+fd.mesh.dx(2:end-1)).*(T(3:end-1)-T(1:end-3))./(fd.mesh.dx(1:end-2)+fd.mesh.dx(2:end-1))]...
%         +[0;(Kia(3:end-1)-Kia(1:end-3))./(fd.mesh.dx(1:end-2)+fd.mesh.dx(2:end-1)).*1./(fd.mesh.dx(1:end-2)+fd.mesh.dx(2:end-1))]);
%         
%      B(:,2)=-(1/(c.*rho))*([DKiaDT(2:end-2)./(fd.mesh.dx(2:end-1)+fd.mesh.dx(3:end)).*(T(4:end)-T(2:end-2))./(fd.mesh.dx(2:end-1)+fd.mesh.dx(3:end));0]...
%         +[(Kia(4:end)-Kia(2:end-2))./(fd.mesh.dx(2:end-1)+fd.mesh.dx(3:end)).*1./(fd.mesh.dx(2:end-1)+fd.mesh.dx(3:end));0]);
%     B=B./(NP.NX^2);
%     MFt=spdiags(B, [1  -1], N,N);
%     deltaT=FTe\MFt;
%     errornorm=norm(deltaT,inf)/norm(FTe);
%     T(2:end-1)=T(2:end-1)+deltaT';
end



