function [p,n,w,Js,Jvt,Jdis,Jtp,Jtn]=DynamicPDsolver(Bias,BF,G0,FL,dir,filenum1,Ae,Be,Ah,Bh,initial_state,p_ini,n_ini,w_ini,Js_ini,DeltaEA,DeltaED,Impact_Ion)
% solving the steady state of pin photodetector
% Bias is the applied reversed voltage, 50 om resitance is included in the
% simulation.
% G0 is the generation rate
% DynamicPDsolver(5,1,1.3e-4,5e9,'Results-G2_3/44/',4,300)
Parameters_NR
BF=BF;
capped=0;
Bias=Bias;

Steptime=2*1e-12/(FL/1e9);
Totaltime=4/FL;

% Fill in unset optional values.
 %up = up/NP.Nmu;
% switch nargin
%     case 10
%         gamma = 4;
%         up = 300/NP.Nmu;
%         %opt3 = @magic;
%     case 11
%         up = 300/NP.Nmu;
%     case 12
%         up = up/NP.Nmu;
% 
% end
% dir13=[dir,'Pra.txt'];
% fid = fopen(dir13,'w');
%  fprintf(fid,'Bias=%8e\r\n',Bias);
%  fclose(fid);
%G0=1.3e-3/10;
%GL(1:N,1)=G0;
%GL(1:N,1)=((30e-4)^2./Diameter.^2)*G0;
%GL(1:N,1)=((7e-4)^2./Diameter.^2)*G0; % per volume
%GL(1:N1,1)=1*Diameter(N2)^2./(30e-4).^2*1*G0;
% Impact_Ion=1;
% G0=((7e-4)^2./Diameter(1).^2)*G0;
%Franz=1;
% initial_state=0;
%Main_Fsolve_N_C_STATE;
[p,n,w,Js,pm,nm,wm,E,NP,pb1,pbn,nb1,nbn,wb1,wbn,fd1,mesh1,ss1,BF,GL,R_load,DeltaEA,DeltaED,alpha_p,alpha_n]=SteadyPDsolver(Bias,BF,G0,Impact_Ion,Ae,Be,Ah,Bh,initial_state,p_ini,n_ini,w_ini,Js_ini,1,DeltaEA,DeltaED);
% p,n, w are the full results, and pm,nm,wm are the norm results except the
% boundary condition. It will be used in the evolution 
[Jvt,Jdis,Steptime,Jtp,Jtn]=Dynamic_time_evolution(pm,nm,wm,E,NP,pb1,pbn,nb1,nbn,wb1,wbn,fd1,mesh1,ss1,BF,Js,GL,FL,R_load,Totaltime,Steptime,Bias,alpha_p,alpha_n);
% save file
dir13=[dir,int2str(filenum1),'/Pra.txt'];
fid = fopen(dir13,'a');
    fprintf(fid,'Steptime=%8e\r\n',Steptime*NP.NT);
    fprintf(fid,'Frequence=%8e\r\n',FL);
    fprintf(fid,'G0=%8e\r\n',G0);
    fprintf(fid,'R_Ebslon2=%8e\r\n',R_Ebslon2); 
    fprintf(fid,'alpha_p=%8e\r,alpha_n=%8e\r\n',ss1.alpha_p,ss1.alpha_n); 
    fprintf(fid,'Layer_Doping=%8e\r\n',Layer_Doping);
    fprintf(fid,'Cap=%8e\r\n',capped);
    fprintf(fid,'Bias=%8e\r\n',Bias);
    fprintf(fid,'gama=%8e\r\n',gamma);
    fprintf(fid,'beta=%8e\r\n',NP.beta*(NP.NX/NP.VT)^2);
    fprintf(fid,'beta2=%8e\r\n',NP.beta2*(NP.NX/NP.VT)^2);
    fprintf(fid,'Phi=%8e\r\n',Phi);
    fprintf(fid,'Vps=%8e\r\n',Vps/(NP.NX/NP.VT/NP.Nmu));
    fprintf(fid,'Vns=%8e\r\n',Vns/(NP.NX/NP.VT/NP.Nmu));
    fprintf(fid,'Ep=%8e\r\n',Ep/(NP.NX/NP.VT));
    fprintf(fid,'Eg1=%8e\r\n',Eg1);
    fprintf(fid,'Cp1=%8e\r,Cp2=%8e\r\n',Cp1/(NP.NT/(NP.NX)^6),Cp2/(NP.NT/(NP.NX)^6));
    fprintf(fid,'Cn1=%8e\r,Cn2=%8e\r\n',Cn1/(NP.NT/(NP.NX)^6),Cn2/(NP.NT/(NP.NX)^6));
    fprintf(fid,'Br1=%8e\r,Br2=%8e\r\n',Br1/(NP.NT/(NP.NX)^3),Br2/(NP.NT/(NP.NX)^3));
    
    fprintf(fid,'t1=%8e\r\n,t2=%8e\r\n',tor1*NP.NT,tor2*NP.NT);
    fprintf(fid,'Intensity=%8e\r\n',G0);
    fprintf(fid,'BF=%8e\r\n',BF);
    fprintf(fid,'un1=%8e\r,un2=%8e\r\n',un1*NP.Nmu,un2*NP.Nmu);
    fprintf(fid,'up1=%8e\r,up2=%8e\r\n',up1*NP.Nmu,up2*NP.Nmu);
    fprintf(fid,'deltaEA=%8e\r\n',DeltaEA);
    fprintf(fid,'deltaED=%8e\r\n',DeltaED);
    fprintf(fid,'R_laod=%8e\r\n',R_load);
    fprintf(fid,'Impact_Ion=%8e\r\n',Impact_Ion);
    fprintf(fid,'Ae=%8e\r\n',Ae);
    fprintf(fid,'Be=%8e\r\n',Be);
    fprintf(fid,'Ah=%8e\r\n',Ah);
    fprintf(fid,'Bh=%8e\r\n',Bh);
    fprintf(fid,'In=%d\r\n',In);
    fprintf(fid,'Franz=%8e\r\n',ss1.Franz);
    fprintf(fid,'Diameter=%8e\r\n',Diameter(1));
    fprintf(fid,'Diameter=%8e\r\n',Diameter(end));
    fclose(fid);
    %fprintf(fid,'Pabsorbtion=%8e\r\n',pabs);
    %un=10000/NP.Nmu;% the electron mobility without Electrical Field, unit cm^2/(V*s)
    %up=200/NP.Nmu



% after this you should save the file current Jvt, and Jdis
