function [Jvt,Jdis,Steptime1,Jtp,Jtn]=Dynamic_time_evolution(pm,nm,wm,E,NP,pb1,pbn,nb1,nbn,wb1,wbn,fd1,mesh1,ss,BF,Js,GL,FL,R_load,Totaltime,Steptime1,Bias,alpha_p,alpha_n)
% this code should follow the State solution Main_Fsolve_N_C_STATE
% The function is to calculate the dynamic output : for example to
% calculate the output of sin light generation.
% the pm ,nm and wm are the normolized hole, electron density and potential
% NP are the normolize class
% DD2 are the drift-diffusion model class
% fd is the finite difference method class
% GL and FL are the light generation rate and frequence
pm0=pm;
nm0=nm;
wm0=wm;
E0=E;
NT=NP.NT;% normolized time
J0=NP.J0; % normolized current
wbf=wb1+Js*R_load/NP.VT;
wbi=wbf+Bias/NP.VT;
Vd2=(Bias-abs(Js)*R_load);
if nargin > 24
    error('myfuns:Dynamic_time_evolution:TooManyInputs', ...
        'requires at most 2 optional inputs');
end

% Fill in unset optional values.
switch nargin
    case 22
        Totaltime=5e-9/NT;
        Steptime1=2e-12/NT;
        %opt3 = @magic;
    case 23
        Totaltime=Totaltime/NT;
        Steptime1=2e-12/NT;
    case 24
        Totaltime=Totaltime/NT;
        Steptime1=Steptime1/NT;

end
% % for the time evolution, 
Diameter=ss.Diameter;
DiameterJ=ss.DiameterJ;
Ebslon=ss.Ebslon;
Steps=Totaltime/Steptime1;
L1=(length(pm));
a=(-1/Steptime1).*[ones(2*L1,1);zeros(L1,1)];
Mt1=spdiags(a,0,3*L1,3*L1);
time(1)=0;
%%%%%%%%%%%%%%%%%%%%%%
% input
% time=2e-13:2e-13:2e-11
% G0=1e-3*(sin(1e12*time)+1)
  for ti=1:Steps
%       if time(ti)<7.9e-9
%           Steptime=200*Steptime1;
%           Mt=Mt1/200;
%       else
          Steptime=1*Steptime1;
          Mt=Mt1/1;
%       end
      time(ti+1)=time(ti)+Steptime*NT;
      if time(ti+1)>Totaltime*NT
          break
      end
      err1=1;
      Vd0=Vd2;
      for res_i=1:50
          wb1=wbi-Vd2/NP.VT;
%       wb1=wbf-Js*R_load/NP.VT;   
      % this is for the case of sin input
      DD2 = Drift_Diff_N_C_GN(pb1,pbn,nb1,nbn,wb1,wbn,fd1,mesh1,ss,NP,BF,alpha_p,alpha_n);
      % this is for the pulse response
%       DD2 = Drift_Diff_N_C_GN_PULSE(pb1,pbn,nb1,nbn,wb1,wbn,fd1,mesh1,ss,NP,BF,alpha_p,alpha_n);
      for i=1:20
          
          if err1<1e-13 && err2_p<1e-7
              %Jvt(ti)=JT(1)*J0;
              %Jvt1(ti)=JT(end)*J0;
              break
              
          end
          
          %Calculate F(x)
          [Fp,Fn,Fw,J1,J2,Jp_drift,Jp_diff,Jn_drift,Jn_diff]=DD2.Cal_Current(pm,nm,wm,time(ti+1),GL,FL);%pm is the hole density except the boundary, the same for nm and wm
          JT=J1+J2;
          %Js1=JT;
%           Js1=trapz(mesh1.Lx_half,(((J1+J2)*J0).*Diameter(1:end-1).^2)/sum(mesh1.dx)*0.25*pi);
%           Jz0=Js1;
          %Jvt(ti)=JT(1)*J0;
          %Jvt1(ti)=JT(end)*J0;
          Fy = -[Fp;Fn;Fw];
          Ft=([pm-pm0;nm-nm0;wm-wm])/Steptime;
          Fy=Fy+Ft;
         % Calculate Jacobian
          %Jacob1 = Jacobm(mesh1,fd1,ss);
          M = DD2.ConsJacobian(pm,nm,wm);
          M=M+Mt;
          %Calculate Newton step
          Deltay = M\Fy;
          if any(isnan(Deltay))
              fprintf('Timestep: %d',ti);
              error('NaN found in timestep');
          end
          err0=norm(M*Deltay-Fy)/norm(Fy);
          
         % Update p,n and w
          pm = pm+Deltay(1:end/3);
          nm = nm+Deltay(end/3+1:2*end/3);
          wm = wm+Deltay(2*end/3+1:end);
          err1=norm(Deltay)/norm([pm;nm;wm]);
          
          err2_p=norm(Fp-(pm-pm0)/Steptime);
          err2_n=norm(Fn-(nm-nm0)/Steptime);
          err2_w=norm(Fw);
          w=NP.VT*[DD2.wb1;wm;DD2.wbn];
          p=NP.Ni*[DD2.pb1;pm;DD2.pbn];
          n=NP.Ni*[DD2.nb1;nm;DD2.nbn];
          E=-(fd1.diffmp(w))/NP.NX;
          
          Jz0=trapz(mesh1.Lx_half,((JT*J0+Ebslon*(E-E0)/(NT*Steptime)).*DiameterJ(1:end-1).^2)/sum(mesh1.dx)*0.25*pi);
          Js1=Jz0;
          %             fprintf('timestep: %d',ti)
%            fprintf('error1: %d\n,',err1)
%            fprintf('error2_p: %d ,error2_n: %d ,error2_w: %d\n',err2_p,err2_n,err2_w)
      end
      if R_load>0
          if res_i==1
              I0=Jz0;
              Vd1=Vd0*1.00002;
              %           Vd1=Bias+Jz0*R_load;
              Vd2=Vd1;
          elseif res_i==2
              I1=Jz0;
              Vd2=Vd1-(Jz0*R_load+Bias-Vd1)*(Vd1-Vd0)/(R_load*(I1-I0)-Vd1+Vd0);
              I0=I1;
          else
              I1=Jz0;
              Vd0=Vd1;
              Vd1=Vd2;
              Vd2=Vd1-(Jz0*R_load+Bias-Vd1)*(Vd1-Vd0)/(R_load*(I1-I0)-Vd1+Vd0);
              I0=I1;
          end
      else
          Vd2=(Bias-abs(Js1)*R_load);
      end
      if abs(Js1-Js)/abs(Js1)<1e-5
          Js=Js1;
          break
      else
          Js=Js1;
          err1=1;
          err2_p=1;
          if res_i==50
              error('Load no converge');
          end
      end
      

      end
      w=NP.VT*[DD2.wb1;wm;DD2.wbn];
      p=NP.Ni*[DD2.pb1;pm;DD2.pbn];
      n=NP.Ni*[DD2.nb1;nm;DD2.nbn];
      E=-(fd1.diffmp(w))/NP.NX;
      
      Jvt(ti)=trapz(mesh1.Lx_half,((JT*J0+Ebslon*(E-E0)/(NT*Steptime)).*DiameterJ(1:end-1).^2)/sum(mesh1.dx)*0.25*pi);%...
          %+trapz(mesh1.Lx_half,(Ebslon*(E-E0)/(Steptime).*(Diameter(1:end-1)).^2)/sum(mesh1.dx)*0.25*pi);% displacement current
      Jtp(ti)=trapz(mesh1.Lx_half,((J1*J0).*DiameterJ(1:end-1).^2)/sum(mesh1.dx)*0.25*pi);
      Jtn(ti)=trapz(mesh1.Lx_half,((J2*J0).*DiameterJ(1:end-1).^2)/sum(mesh1.dx)*0.25*pi);
          Jdis(ti)=trapz(mesh1.Lx_half,((Ebslon*(E-E0)/(NT*Steptime)).*DiameterJ(1:end-1).^2)/sum(mesh1.dx)*0.25*pi);% displacement
      % consider the displacement current will influence the Load voltage.
%       if ti>1
%           Jdis1(ti)=0.25*pi*Diameter(1)^2*Ebslon*50*(Jvt(ti-1)-Jvt(ti))/(2.05e-4*NT*Steptime);
%       else
%           Jdis1=0;
%       end
      L=mesh1.Lx*NP.NX;
      
      %Jvt1(ti)=JT(1)*J0*pi*(4.2e-4)^2;%+Ebslon*(E(1)-E0(1))/(Steptime*NT);% un normolized value
      if 0%Bias==4
          dir001=['Results/G3/D02'];
          dir11=[dir001,'/L.txt'];
          fid = fopen(dir11,'w');
          fprintf(fid,'%8e\r\n',L);
          fclose(fid);
          dir13=[dir001,'/Pra2.txt'];
          fid = fopen(dir13,'w');
          fprintf(fid,'Steptime=%8e\r\n',Steptime*NT);
          fprintf(fid,'Frequence=%8e\r\n',FL);
          fprintf(fid,'Bias=%8e\r\n',Bias);
%           fprintf(fid,'BF=%8e\r\n',BF); %un=10000/NP.Nmu;% the electron mobility without Electrical Field, unit cm^2/(V*s)
          %up=200/NP.Nmu
%           fprintf(fid,'Alphap=%8e\r\n',alphap);
%           fprintf(fid,'Alphan=%8e\r\n',alphan);
%           fprintf(fid,'un=%8e\r,up=%8e\r\n',un*NP.Nmu,up*NP.Nmu);
%           fprintf(fid,'Diameter=%8e\r\n',Diameter);
          fclose(fid);
      end
      if  0%Bias==2| Bias==4.5%time(ti)>(50*2.0e-10)-(2e-10)
          dir11=[dir001,'/Jp',int2str(2*Bias),int2str(ti),'.txt'];
          fid = fopen(dir11,'w');
          fprintf(fid,'%8e\r\n',J1*J0*pi*0.25.*DiameterJ(1:end-1).^2);
          fclose(fid);
          dir11=[dir001,'/Jp_drift',int2str(2*Bias),int2str(ti),'.txt'];
          fid = fopen(dir11,'w');
          fprintf(fid,'%8e\r\n',Jp_drift*J0*pi*0.25.*DiameterJ(1:end-1).^2);
          fclose(fid);
          dir11=[dir001,'/Jp_diff',int2str(2*Bias),int2str(ti),'.txt'];
          fid = fopen(dir11,'w');
          fprintf(fid,'%8e\r\n',Jp_diff*J0*pi*0.25.*DiameterJ(1:end-1).^2);
          fclose(fid);
          dir11=[dir001,'/Jn',int2str(2*Bias),int2str(ti),'.txt'];
          fid = fopen(dir11,'w');
          fprintf(fid,'%8e\r\n',J2*J0*pi*0.25.*DiameterJ(1:end-1).^2);
          fclose(fid);
          dir11=[dir001,'/Jn_drift',int2str(2*Bias),int2str(ti),'.txt'];
          fid = fopen(dir11,'w');
          fprintf(fid,'%8e\r\n',Jn_drift*J0*pi*0.25.*DiameterJ(1:end-1).^2);
          fclose(fid);
          dir11=[dir001,'/Jn_diff',int2str(2*Bias),int2str(ti),'.txt'];
          fid = fopen(dir11,'w');
          fprintf(fid,'%8e\r\n',Jn_diff*J0*pi*0.25.*DiameterJ(1:end-1).^2);
          fclose(fid);
          dir11=[dir001,'/Jd',int2str(2*Bias),int2str(ti),'.txt'];
          fid = fopen(dir11,'w');
          fprintf(fid,'%8e\r\n',Ebslon*(E-E0)/(NT*Steptime)*pi*0.25.*DiameterJ(1:end-1).^2);
          fclose(fid);
%           dir11=[dir001,'/Jpdrift',int2str(ii),int2str(ti),'.txt'];
%           fid = fopen(dir11,'w');
%           fprintf(fid,'%8e\r\n',Jpdrift*J0);
%           fclose(fid);
%           dir11=[dir001,'/Jpdiff',int2str(ii),int2str(ti),'.txt'];
%           fid = fopen(dir11,'w');
%           fprintf(fid,'%8e\r\n',Jpdiff*J0);
%           fclose(fid);
          
          
          %           subplot(211)
          %           %plot([1:ti]*deltat,pevol,'gx')
          %           plot(L(2:N),E,'r')
          %           hold on;
          %
          %           subplot(212)
          %           plot(L,log10(p),'r')
          %           hold on
          %%           plot(L,log10(n),'r')
          %           pause(1)
      end
      E0=E;
      pm0=pm; % for the time evolution to record the last timestep carrier density and potential
      nm0=nm;
      wm0=wm;
  end
%[x,fval,exitflag,output,jacobian]=fsolve(@DD2.Newton_FD,x,opts);
%%%%%%%%%%%%%
%plot(time(2:end),Jvt)
% p=Ni*[pb1;pm;pbn];
% n=Ni*[nb1;nm;nbn];
% w=VT*[wb1;wm;wbn];
% %%%%%%%%%%%%%
% 
% L=NX*mesh1.Lx;
% %%%%%%%%%%%
% E=-(fd1.diffmp(w))/NX;
